#!/usr/bin/python
# -*- coding: utf-8 -*-
### START BOILERPLATE CODE

# Sample Python code for user authorization

import httplib2
import os
import sys
import serial
import time
from datetime import datetime
import requests

from apiclient.discovery import build
from apiclient.errors import HttpError
from oauth2client.client import flow_from_clientsecrets
from oauth2client.file import Storage
from oauth2client.tools import argparser, run_flow

# The CLIENT_SECRETS_FILE variable specifies the name of a file that contains
# the OAuth 2.0 information for this application, including its client_id and
# client_secret.
CLIENT_SECRETS_FILE = "client_secrets.json"

# This OAuth 2.0 access scope allows for full read/write access to the
# authenticated user's account and requires requests to use an SSL connection.
YOUTUBE_READ_WRITE_SSL_SCOPE = "https://www.googleapis.com/auth/youtube.force-ssl"
API_SERVICE_NAME = "youtube"
API_VERSION = "v3"

# This variable defines a message to display if the CLIENT_SECRETS_FILE is
# missing.
MISSING_CLIENT_SECRETS_MESSAGE = "WARNING: Please configure OAuth 2.0" 

# Authorize the request and store authorization credentials.
def get_authenticated_service(args):
  flow = flow_from_clientsecrets(CLIENT_SECRETS_FILE, scope=YOUTUBE_READ_WRITE_SSL_SCOPE,
    message=MISSING_CLIENT_SECRETS_MESSAGE)

  storage = Storage("youtube-api-snippets-oauth2.json")
  credentials = storage.get()

  if credentials is None or credentials.invalid:
    credentials = run_flow(flow, storage, args)

  # Trusted testers can download this discovery document from the developers page
  # and it should be in the same directory with the code.
  return build(API_SERVICE_NAME, API_VERSION,
      http=credentials.authorize(httplib2.Http()))

args = argparser.parse_args()
service = get_authenticated_service(args)

def print_results(results):
  print(results)

# Build a resource based on a list of properties given as key-value pairs.
# Leave properties with empty values out of the inserted resource.
def build_resource(properties):
  resource = {}
  for p in properties:
    # Given a key like "snippet.title", split into "snippet" and "title", where
    # "snippet" will be an object and "title" will be a property in that object.
    prop_array = p.split('.')
    ref = resource
    for pa in range(0, len(prop_array)):
      is_array = False
      key = prop_array[pa]
      # Convert a name like "snippet.tags[]" to snippet.tags, but handle
      # the value as an array.
      if key[-2:] == '[]':
        key = key[0:len(key)-2:]
        is_array = True
      if pa == (len(prop_array) - 1):
        # Leave properties without values out of inserted resource.
        if properties[p]:
          if is_array:
            ref[key] = properties[p].split(',')
          else:
            ref[key] = properties[p]
      elif key not in ref:
        # For example, the property is "snippet.title", but the resource does
        # not yet have a "snippet" object. Create the snippet object here.
        # Setting "ref = ref[key]" means that in the next time through the
        # "for pa in range ..." loop, we will be setting a property in the
        # resource's "snippet" object.
        ref[key] = {}
        ref = ref[key]
      else:
        # For example, the property is "snippet.description", and the resource
        # already has a "snippet" object.
        ref = ref[key]
  return resource

# Remove keyword arguments that are not set
def remove_empty_kwargs(**kwargs):
  good_kwargs = {}
  if kwargs is not None:
    for key, value in kwargs.iteritems():
      if value:
        good_kwargs[key] = value
  return good_kwargs

print("Start.../n")
### END BOILERPLATE CODE

# Sample python code for channels.list
ser = serial.Serial('/dev/ttyS1',9600)
print(ser.name)

def weather():
  s_city = "Irkutsk,RU"
  city_id = 2023469
  appid = "d30181ddf35f2dc64cb60c4e99b12a73"
  try:
    res = requests.get("http://api.openweathermap.org/data/2.5/weather",
                 params={'id': city_id, 'units': 'metric', 'lang': 'ru', 'APPID': appid})
    data = res.json()
   # print "conditions: ", data['weather'][0]['description']
    ser.write('condition.txt="'+data['weather'][0]['description'].encode('koi8-r')+'"')
    ser.write('\xFF')
    ser.write('\xFF')
    ser.write('\xFF')
   # print datetime.fromtimestamp(int(data['dt']))
   # print "Temp:", data['main']['temp']
    ser.write('grad.txt="'+str(data['main']['temp'])+'"')
    ser.write('\xFF')
    ser.write('\xFF')
    ser.write('\xFF')
   # print "davlenie", data['main']['pressure']
   # print "Vlajnost", data['main']['humidity']
  except Exception as e:
    print("Exception (weather):", e)
    pass

def send_fucking_number(number):
  file=open("save_subs.txt")
  save_subs_str=file.read()
  file.close()
  old_number=int(save_subs_str)
  print old_number
  ser.write('dsub.val='+str(number-old_number))
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')

def channels_list_by_id(service, **kwargs):
  kwargs = remove_empty_kwargs(**kwargs) # See full sample for function
  results = service.channels().list(**kwargs).execute()
  subs_count=int(results['items'][0]['statistics']['subscriberCount'])
  ser.write('sub_count.val=')
  ser.write(str(subs_count))
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')
  send_fucking_number(subs_count)

def comment_threads_list_all_threads_by_channel_id(service, **kwargs):
  kwargs = remove_empty_kwargs(**kwargs) # See full sample for function
  results = service.commentThreads().list(
    **kwargs
  ).execute()

  #print_results(results['items'][0]['snippet']['topLevelComment']['snippet']['textOriginal'])
  ser.write('t0.txt="'+results['items'][0]['snippet']['topLevelComment']['snippet']['textOriginal'][0:127].encode('koi8-r').replace('"', '$')+'"')
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')
# print_results(results['items'][1]['snippet']['topLevelComment']['snippet']['textOriginal'])
  ser.write('t1.txt="'+results['items'][1]['snippet']['topLevelComment']['snippet']['textOriginal'][0:127].encode('koi8-r').replace('"', '$')+'"')
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')
 # print_results(results['items'][2]['snippet']['topLevelComment']['snippet']['textOriginal'])
  ser.write('t2.txt="'+results['items'][2]['snippet']['topLevelComment']['snippet']['textOriginal'][0:127].encode('koi8-r').replace('"', '$')+'"')
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')
 # print_results(results['items'][3]['snippet']['topLevelComment']['snippet']['textOriginal'])
  ser.write('t3.txt="'+results['items'][3]['snippet']['topLevelComment']['snippet']['textOriginal'][0:127].encode('koi8-r').replace('"', '$')+'"')
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')
 # print_results(results['items'][4]['snippet']['topLevelComment']['snippet']['textOriginal'])
  ser.write('t4.txt="'+results['items'][4]['snippet']['topLevelComment']['snippet']['textOriginal'][0:127].encode('koi8-r').replace('"', '$')+'"')
  ser.write('\xFF')
  ser.write('\xFF')
  ser.write('\xFF')

subs_count=0

channels_list_by_id(service,
    part='snippet,contentDetails,statistics',
    id='UCpDN_JJKUKUjs0e88kFC3Ig')
comment_threads_list_all_threads_by_channel_id(service,
    part='snippet,replies',
    allThreadsRelatedToChannelId='UCpDN_JJKUKUjs0e88kFC3Ig')
weather()

